//************************************************************
//  University of Patras 
//      Department of Electrical Engineering & Computer Technology
//       
//      Course: Parallel Programming in AI 
//      Week 03: pThreads parallel programming methods
//     
//      pThreads04.c: Passing parameters without pthread_joint() function
//                       but using the pthread_exit()  
//      Author: Evangelos Dermatas
//      v0.1
/*
*********************************************************************
gcc -v: gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 18.04
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:      gcc pThreads04.c -o pThreads04 -lpthread
Executing:      ./pThreads04

Output in my Laptop:
Before Thread
Printing 0 2 2
Printing 1 2 2
Printing 2 4 4
Printing 3 4 4
Printing 4 5 5
Printing 5 6 6
Printing 6 7 7
Printing 7 8 8
Printing 8 9 9
Printing 9 10 10

*********************************************************************
*/

#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>  
#include <pthread.h> 
  

//************************************************************

//************************************************************
void *myThreadFun(void *vargp) 
{ 
	static int i =0 ;
    printf("Printing %d %d\n", i++, *((int *)vargp));
    *(int *)vargp++ ;
    return NULL; 
} 


//************************************************************
int main() 
{
    pthread_t thread_id[10];

    printf("Before Thread\n");
    for( int  j= 0 ; j < 10 ; j++ ) {        printf( "In Main j=%d", j ) ;
    	pthread_create(&(thread_id[j]), NULL, myThreadFun, (void *) (&j));
    }
    printf("After Thread\n"); 

    pthread_exit(NULL) ;

    printf("After Thread exit\n"); 
    exit(0); 
}

